; @author Sylwester Arabas <slayoo@igf.fuw.edu.pl>

pro IGFLibFastFSSPData::focusOnTime, time
  compile_opt idl2, strictarr

  print, "Focusing FastFSSP on time ", time*1000L

  values = (*(self.source))->readDataFromFile( $
    [17,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,19], $
    constraint_col=0L, $
    constraint_val=100L*(indgen(40)-self.tuneoffset) + 1000L*time, $
    /constraint_linear, $
    limit=40L $
  );
  
  for s=0, n_elements(self.curr_hist)-1 do begin

    vals = dblarr(21);
    vals[0] = 3.;
    for i=1, n_elements(*values)-1 do begin
      vals[i] = (*((*values)[i]))[s]/1000.;
    endfor  
    vals[20] = 50.;

    (*(self.curr_hist[s]))->flush;
    for i=0, n_elements(vals)-2 do (*(self.curr_hist[s]))->addBin, vals[i], vals[i+1], (*((*values)[0]))[s] / 20.; 
    (*(self.curr_hist[s]))->commit;

    self->setControllVar, (*((*values)[20]))[s]/1000., s;

  endfor

  self.curr_time = time;
end
